NX二开ufun函数UF_MODL_ask_bounding_box(获取边界坐标)

2023-10-27 21:10

本文主要是介绍NX二开ufun函数UF_MODL_ask_bounding_box(获取边界坐标),希望对大家解决编程问题提供一定的参考价值,需要的开发者们随着小编来一起学习吧!

这个函数用来返回线框和实体类型对象的边界框。
线框对象包括直线,圆弧,样条曲线和圆锥曲线。实体类型对象包括实体 ,面和边。

返回结果如下图,分别返回了曲线和一个block的边界信息:

1、函数结构: 

int UF_MODL_ask_bounding_box (tag_t obj_tag,double bounding_box [6])

2、概述

返回线框和实体类型对象的边界框。 
线框对象包括直线,圆弧,样条曲线和圆锥曲线。实体类型对象包括实体 ,面和边。
根据零件文件中对象的位置,以绝对坐标值返回 边界框值 。

3、实例源码

1)C# 实例源码

using System;
using NXOpen;
using NXOpen.UF;
using NXOpen.Features;public class Program
{// class memberspublic static Session theSession;public static NXOpen.UF.UFSession theUFSession;private static UI theUI = null;public static Part workPart;public static int Main(string[] args){theSession = Session.GetSession();theUFSession = UFSession.GetUFSession();theUI = UI.GetUI();workPart = theSession.Parts.Work;int retValue = 0;try{Tag arc, wcs;UFCurve.Arc arc_coords = new UFCurve.Arc();arc_coords.start_angle = 0.0;arc_coords.end_angle = 3.0;arc_coords.arc_center = new double[3];arc_coords.arc_center[0] = 0.0;arc_coords.arc_center[1] = 0.0;arc_coords.arc_center[2] = 1.0;arc_coords.radius = 2.0;theUFSession.Csys.AskWcs(out wcs);theUFSession.Csys.AskMatrixOfObject(wcs, out arc_coords.matrix_tag);theUFSession.Curve.CreateArc(ref arc_coords, out arc);FeatureSigns sign = 0;double[] corner = new double[3]{0.0, 0.0, 0.0};string[] edgeLen = new string[3] {"100","80","50"};Tag blockTag = Tag.Null;theUFSession.Modl.CreateBlock1(sign, corner, edgeLen, out blockTag);Tag blockBodyTag = Tag.Null;theUFSession.Modl.AskFeatBody(blockTag, out blockBodyTag);double[] boxArc = new double[6];theUFSession.Modl.AskBoundingBox(arc, boxArc);double[] boxBlock = new double[6];theUFSession.Modl.AskBoundingBox(blockBodyTag, boxBlock);}catch (NXOpen.NXException ex){theUI.NXMessageBox.Show("Block Styler", NXMessageBox.DialogType.Error, ex.ToString());}return retValue;}
}

2)C++实例源码

#include <stdio.h>
#include <uf.h>
#include <uf_part.h>
#include <uf_curve.h>
#include <uf_modl.h>
#include <uf_csys.h>
#include <uf_defs.h>
#define UF_CALL(X) (report( __FILE__, __LINE__, #X, (X)))
static int report( char *file, int line, char *call, int irc)
{if (irc){char    messg[133];printf("%s, line %d:  %s\n", file, line, call);(UF_get_fail_message(irc, messg)) ?printf("    returned a %d\n", irc) :printf("    returned error %d:  %s\n", irc, messg);}return(irc);
}
static void do_ugopen_api(void)
{char *part_name = "bound";tag_t part, arc_id, wcs_tag;double box[6];UF_CURVE_arc_t arc_coords;/* Fill out the data structure */arc_coords.start_angle = 0.0;arc_coords.end_angle = 270.0 * DEGRA;arc_coords.arc_center[0] = 0.0;arc_coords.arc_center[1] = 0.0;arc_coords.arc_center[2] = 1.0;arc_coords.radius = 2.0;UF_PART_new(part_name, UF_PART_ENGLISH, &part);UF_CSYS_ask_wcs( &wcs_tag );UF_CSYS_ask_matrix_of_object( wcs_tag,&arc_coords.matrix_tag );/* Create arc */UF_CURVE_create_arc(&arc_coords,&arc_id);/* Ask bounding box of arc */UF_MODL_ask_bounding_box(arc_id,box);/* Print bounding box values */printf("\nMinimum x value: %f\n", box[0]);printf("Maximum x value: %f\n", box[3]);printf("Minimum y value: %f\n", box[1]);printf("Maximum y value: %f\n", box[4]);printf("Minimum z value: %f\n", box[2]);printf("Maximum z value: %f\n", box[5]);
}
/*ARGSUSED*/
void ufusr(char *param, int *retcode, int param_len)
{if (!UF_CALL(UF_initialize())){do_ugopen_api();UF_CALL(UF_terminate());}
}
int ufusr_ask_unload(void)
{return (UF_UNLOAD_IMMEDIATELY);
}

这篇关于NX二开ufun函数UF_MODL_ask_bounding_box(获取边界坐标)的文章就介绍到这儿,希望我们推荐的文章对编程师们有所帮助!



http://www.chinasem.cn/article/288408

相关文章

hdu1171(母函数或多重背包)

题意:把物品分成两份,使得价值最接近 可以用背包,或者是母函数来解,母函数(1 + x^v+x^2v+.....+x^num*v)(1 + x^v+x^2v+.....+x^num*v)(1 + x^v+x^2v+.....+x^num*v) 其中指数为价值,每一项的数目为(该物品数+1)个 代码如下: #include<iostream>#include<algorithm>

C++操作符重载实例(独立函数)

C++操作符重载实例,我们把坐标值CVector的加法进行重载,计算c3=c1+c2时,也就是计算x3=x1+x2,y3=y1+y2,今天我们以独立函数的方式重载操作符+(加号),以下是C++代码: c1802.cpp源代码: D:\YcjWork\CppTour>vim c1802.cpp #include <iostream>using namespace std;/*** 以独立函数

函数式编程思想

我们经常会用到各种各样的编程思想,例如面向过程、面向对象。不过笔者在该博客简单介绍一下函数式编程思想. 如果对函数式编程思想进行概括,就是f(x) = na(x) , y=uf(x)…至于其他的编程思想,可能是y=a(x)+b(x)+c(x)…,也有可能是y=f(x)=f(x)/a + f(x)/b+f(x)/c… 面向过程的指令式编程 面向过程,简单理解就是y=a(x)+b(x)+c(x)

Android Environment 获取的路径问题

1. 以获取 /System 路径为例 /*** Return root of the "system" partition holding the core Android OS.* Always present and mounted read-only.*/public static @NonNull File getRootDirectory() {return DIR_ANDR

利用matlab bar函数绘制较为复杂的柱状图,并在图中进行适当标注

示例代码和结果如下:小疑问:如何自动选择合适的坐标位置对柱状图的数值大小进行标注?😂 clear; close all;x = 1:3;aa=[28.6321521955954 26.2453660695847 21.69102348512086.93747104431360 6.25442246899816 3.342835958564245.51365061796319 4.87

OpenCV结构分析与形状描述符(11)椭圆拟合函数fitEllipse()的使用

操作系统:ubuntu22.04 OpenCV版本:OpenCV4.9 IDE:Visual Studio Code 编程语言:C++11 算法描述 围绕一组2D点拟合一个椭圆。 该函数计算出一个椭圆,该椭圆在最小二乘意义上最好地拟合一组2D点。它返回一个内切椭圆的旋转矩形。使用了由[90]描述的第一个算法。开发者应该注意,由于数据点靠近包含的 Mat 元素的边界,返回的椭圆/旋转矩形数据

论文翻译:ICLR-2024 PROVING TEST SET CONTAMINATION IN BLACK BOX LANGUAGE MODELS

PROVING TEST SET CONTAMINATION IN BLACK BOX LANGUAGE MODELS https://openreview.net/forum?id=KS8mIvetg2 验证测试集污染在黑盒语言模型中 文章目录 验证测试集污染在黑盒语言模型中摘要1 引言 摘要 大型语言模型是在大量互联网数据上训练的,这引发了人们的担忧和猜测,即它们可能已

Unity3D 运动之Move函数和translate

CharacterController.Move 移动 function Move (motion : Vector3) : CollisionFlags Description描述 A more complex move function taking absolute movement deltas. 一个更加复杂的运动函数,每次都绝对运动。 Attempts to

JS和jQuery获取节点的兄弟,父级,子级元素

原文转自http://blog.csdn.net/duanshuyong/article/details/7562423 先说一下JS的获取方法,其要比JQUERY的方法麻烦很多,后面以JQUERY的方法作对比。 JS的方法会比JQUERY麻烦很多,主要则是因为FF浏览器,FF浏览器会把你的换行也当最DOM元素。 <div id="test"><div></div><div></div

✨机器学习笔记(二)—— 线性回归、代价函数、梯度下降

1️⃣线性回归(linear regression) f w , b ( x ) = w x + b f_{w,b}(x) = wx + b fw,b​(x)=wx+b 🎈A linear regression model predicting house prices: 如图是机器学习通过监督学习运用线性回归模型来预测房价的例子,当房屋大小为1250 f e e t 2 feet^